<?php
/**
* @version      3.5.2 20.03.2012
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class JshoppingControllerStates extends JControllerLegacy{
    
    function __construct( $config = array() ){
        
        parent::__construct( $config );
        JSFactory::loadExtLanguageFile('addon_states'); 
        $this->registerTask( 'add',   'edit' );
        $this->registerTask( 'apply', 'save' );
        checkAccessController("states");
        addSubmenu("other");
        
    }

    function display($cachable = false, $urlparams = false){  	        		
        $mainframe = JFactory::getApplication();
		$context = "jshoping.list.admin.states";
        $limit = $mainframe->getUserStateFromRequest( $context.'limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
        $limitstart = $mainframe->getUserStateFromRequest( $context.'limitstart', 'limitstart', 0, 'int' );
        $publish = $mainframe->getUserStateFromRequest( $context.'publish', 'publish', 0, 'int' );
        $country_id = $mainframe->getUserStateFromRequest( $context.'country_id', 'country_id', 0, 'int' );  
		
		$states = $this->getModel("states");

        if ($publish == 0) {
            $total = $states->getCountAllStates($country_id); 
        } else {
            $total = $states->getCountPublishStates($publish % 2, $country_id);
        }
		
		jimport('joomla.html.pagination');
        $pageNav = new JPagination($total, $limitstart, $limit);
		$rows = $states->getAllStates($publish, $pageNav->limitstart,$pageNav->limit, 0, $country_id);
        
        $countries = $states->getAllCountries(); 
		$parentTop = new stdClass();
        $parentTop->country_id = 0;
        $parentTop->name = _JSHOP_ALL;

        array_unshift($countries, $parentTop);    
        $filter = array();
		$filter['countries'] = JHTML::_('select.genericlist', $countries,'country_id','class="inputbox" onchange = "document.adminForm.submit();"','country_id','name', $country_id );
                
        
        $f_option = array();
        $f_option[] = JHTML::_('select.option', 0, _JSHOP_ALL, 'id', 'name');
        $f_option[] = JHTML::_('select.option', 1, _JSHOP_PUBLISH, 'id', 'name');
        $f_option[] = JHTML::_('select.option', 2, _JSHOP_UNPUBLISH, 'id', 'name');
        
        $filter['publish'] = JHTML::_('select.genericlist', $f_option, 'publish', 'onchange="document.adminForm.submit();"', 'id', 'name', $publish);
        
        $country_active= $states->getCountryById($country_id);
                
		$view = $this->getView("states", 'html');
        $view->setLayout("list");	
        $view->assign('country_active', $country_active); 	
        $view->assign('rows', $rows); 
        $view->assign('pageNav', $pageNav);       
        $view->assign('filter', $filter);
		$view->displayList(); 
    }
    
   	function edit() {
		$state_id = JRequest::getInt("state_id");
        
        $mainframe = JFactory::getApplication();
        $context = "jshoping.list.admin.states";        
        $country_id = $mainframe->getUserStateFromRequest( $context.'country_id', 'country_id', 0, 'int' );          
        
		$states = $this->getModel("states");   
		$state = JTable::getInstance('state', 'jshop');
		$state->load($state_id);
        
		$first = array();
		$first[] = JHTML::_('select.option', '0',_JSHOP_ORDERING_FIRST,'ordering','name');
		$rows = array_merge($first, $states->getAllStates(0,null,null,1,$country_id));
		$lists = array();
		$lists['order_states'] = JHTML::_('select.genericlist', $rows,'ordering','class="inputbox" size="1"','ordering','name', $state->ordering);
        
        $_lang = $this->getModel("languages");
        $languages = $_lang->getAllLanguages(1);
        $multilang = count($languages)>1;        
        
		$edit = ($state_id)?($edit = 1):($edit = 0);                
        
        JFilterOutput::objectHTMLSafe( $state, ENT_QUOTES);
        

        $countries = $states->getAllCountries(); 
        $parentTop = new stdClass();
		$parentTop->country_id = 0;
        $parentTop->name = _JSHOP_ALL;

        if ($state_id) $country_id = $state->country_id;
        
        array_unshift($countries, $parentTop);    
        $countries_list = JHTML::_('select.genericlist', $countries,'country_id','class="inputbox" ','country_id','name', $country_id );
                

		$view=$this->getView("states", 'html');
        $view->setLayout("edit");
        $view->assign('countries_list', $countries_list);		
        $view->assign('state', $state); 
        $view->assign('lists', $lists);       
        $view->assign('edit', $edit);
        $view->assign('languages', $languages);
        $view->assign('multilang', $multilang);
        JPluginHelper::importPlugin('jshoppingadmin');
        $dispatcher = JDispatcher::getInstance();
        $dispatcher->trigger('onBeforeEditStates', array(&$view));
		$view->displayEdit();
	}
	
	function save() {
        JPluginHelper::importPlugin('jshoppingadmin');
        $dispatcher = JDispatcher::getInstance();
        
		$state_id = JRequest::getInt("state_id");		
	    $post = JRequest::get('post');
        
        $dispatcher->trigger( 'onBeforeSaveState', array(&$post) );
        
		$state = JTable::getInstance('state', 'jshop');
        
		if (!$state->bind($post)) {
			JError::raiseWarning("",_JSHOP_ERROR_BIND);
			$this->setRedirect("index.php?option=com_jshopping&controller=states");
			return 0;
		}
	
		if (!$state->state_publish){
			$state->state_publish = 0;
	    }    
		$this->_reorderState($state);
		if (!$state->store()) {
			JError::raiseWarning("",_JSHOP_ERROR_SAVE_DATABASE);
			$this->setRedirect("index.php?option=com_jshopping&controller=states");
			return 0;
		}
                
        $dispatcher->trigger( 'onAfterSaveState', array(&$state) );
        
		if ($this->getTask()=='apply'){
            $this->setRedirect("index.php?option=com_jshopping&controller=states&task=edit&state_id=".$state->state_id); 
        }else{
            $this->setRedirect("index.php?option=com_jshopping&controller=states");
        }
	}
	
	function _reorderState(&$state) {
		$db = JFactory::getDBO();
		$query = "UPDATE `#__jshopping_states` SET `ordering` = ordering + 1
					WHERE `ordering` > '" . $state->ordering . "' ";
		$db->setQuery($query);
		$db->query();
		$state->ordering++;
	}
	
	function order(){
		$order = JRequest::getVar("order"); 
		$cid = JRequest::getInt("id");
		$number = JRequest::getInt("number");
		$db = JFactory::getDBO();
        
        $mainframe = JFactory::getApplication();
        $context = "jshoping.list.admin.states";        
        $country_id = $mainframe->getUserStateFromRequest( $context.'country_id', 'country_id', 0, 'int' );  
        if ($country_id!=0)   $where_country= " AND country_id = ".$country_id." ";
        else $where_country = "";    

		switch ($order) {
			case 'up':
				$query = "SELECT a.state_id, a.ordering
					   FROM `#__jshopping_states` AS a
					   WHERE a.ordering < '" . $number . "' ".$where_country." 
					   ORDER BY a.ordering DESC
					   LIMIT 1";
				break;
			case 'down':
				$query = "SELECT a.state_id, a.ordering
					   FROM `#__jshopping_states` AS a
					   WHERE a.ordering > '" . $number . "' ".$where_country." 
					   ORDER BY a.ordering ASC
					   LIMIT 1";
		}
	
		$db->setQuery($query);
		$row = $db->loadObject();
	
	
		$query1 = "UPDATE `#__jshopping_states` AS a
					 SET a.ordering = '" . $row->ordering . "'
					 WHERE a.state_id = '" . $cid . "'";
		$query2 = "UPDATE `#__jshopping_states` AS a
					 SET a.ordering = '" . $number . "'
					 WHERE a.state_id = '" . $row->state_id . "'";
		$db->setQuery($query1);
		$db->query();
		$db->setQuery($query2);
		$db->query();
		
		$this->setRedirect("index.php?option=com_jshopping&controller=states");
	}
	
	function remove() {
		$db = JFactory::getDBO();
		$query = '';
		$text = '';
		$cid = JRequest::getVar("cid");
        JPluginHelper::importPlugin('jshoppingadmin');
        $dispatcher = JDispatcher::getInstance();
        $dispatcher->trigger( 'onBeforeRemoveState', array(&$cid) );
        
		foreach ($cid as $key => $value) {
			$query = "DELETE FROM `#__jshopping_states`
					   WHERE `state_id` = '" . $db->escape($value) . "'";
			$db->setQuery($query);
			if ($db->query())
				$text .= _JSHOP_STATE_DELETED."<br>";
			else
				$text .= _JSHOP_ERROR_SAVE_DATABASE."<br>";	
		}
        
        $dispatcher->trigger( 'onAfterRemoveState', array(&$cid) );

		$this->setRedirect("index.php?option=com_jshopping&controller=states", $text);
	}
	
    function publish(){
        $this->publishState(1);
    }
    
    function unpublish(){
        $this->publishState(0);
    }
    
	function publishState($flag) {
		$cid = JRequest::getVar("cid");
		$db = JFactory::getDBO();
        JPluginHelper::importPlugin('jshoppingadmin');
        $dispatcher = JDispatcher::getInstance();
        $dispatcher->trigger( 'onBeforePublishState', array(&$cid, &$flag) );
		foreach ($cid as $key => $value) {
			$query = "UPDATE `#__jshopping_states` SET `state_publish` = '".$db->escape($flag)."' WHERE `state_id` = '" . $db->escape($value) . "'";
			$db->setQuery($query);
			$db->query();
		}
                
        $dispatcher->trigger( 'onAfterPublishState', array(&$cid, &$flag) );
		
		$this->setRedirect("index.php?option=com_jshopping&controller=states");
	}
    
    function saveorder(){
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        $order = JRequest::getVar( 'order', array(), 'post', 'array' );
        
        foreach ($cid as $k=>$id){
            $state = JTable::getInstance('state', 'jshop');
            $state->load($id);
            if ($state->ordering!=$order[$k]){
                $state->ordering = $order[$k];
                $state->store();
            }        
        }
        
        $state = JTable::getInstance('state', 'jshop');
        $state->reorder();        
                
        $this->setRedirect("index.php?option=com_jshopping&controller=states");
    } 
}

?>