<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class JshoppingControllerStatus_Text extends JControllerLegacy{
    public function __construct($config = array()) {
        JSFactory::loadExtAdminLanguageFile('status_text');
        parent::__construct($config);
    }
    
    public function save(){
        $post = JRequest::get('post', 2);
        $status_id = JRequest::getInt('status_id');
        $addon_id = JRequest::getInt('addonId');

        if (!$status_id || !is_numeric($status_id)){
            JError::raiseWarning('', _JSHOP_ITOS_INVALID_URL);
            JFactory::getApplication()->redirect('index.php?option=com_jshopping&controller=addons&task=edit&id='.$addon_id);
            return 0;;
        }
        
        $orderStatus = JTable::getInstance('orderstatus', 'jshop');
        $orderStatus->load($status_id);
        
        $_lang = $this->getModel("languages");
        $languages = $_lang->getAllLanguages(1);
        
        $data = array();
        foreach ($languages as $lang){
            //$data['email_text']['text_'.$lang->language] = urlencode($post['text_'.$lang->language]);
            $data['email_text']['text_'.$lang->language] = $post['text_'.$lang->language];
        }
        $data['email_text'] = serialize($data['email_text']);

        if (!$orderStatus->bind($data)) {
            JError::raiseWarning("",_JSHOP_ERROR_BIND);
            $this->setRedirect('index.php?option=com_jshopping&controller=addons&task=edit&id='.$addon_id);
            return 0;
        }
        
        if (!$orderStatus->store()){
            JError::raiseWarning("",_JSHOP_ERROR_SAVE_DATABASE);
            $this->setRedirect('index.php?option=com_jshopping&controller=addons&task=edit&id='.$addon_id);
            return 0;
        }
        
        $this->setRedirect('index.php?option=com_jshopping&controller=addons&task=edit&id='.$addon_id, _JSHOP_ITOS_STATUS_TEXT_SAVED);
    }
    
    public function edit(){
        addSubmenu('other');
        $addon = JTable::getInstance('addon', 'jshop');
        $addon->loadAlias('status_text');

        $id = JRequest::getInt('id');
        
        if (!$id || !is_numeric($id)){
            JError::raiseWarning('', _JSHOP_ITOS_INVALID_URL);
            JFactory::getApplication()->redirect('index.php?option=com_jshopping&controller=addons');
            return 0;;
        }
        $orderStatus = JTable::getInstance('orderstatus', 'jshop');
        $orderStatus->load($id);
        
        $_lang = $this->getModel("languages");
        $languages = $_lang->getAllLanguages(1);
        $multilang = count($languages)>1;

        $view = $this->getView('status_text', 'html');
        $message = array();
        
        if (!isset($orderStatus->email_text) || empty($orderStatus->email_text)){
            $view->setLayout('default_message');
            
            foreach($languages as $lang){
                $fileArray = file(JPATH_ROOT.'/components/com_jshopping/lang/'.$lang->language.'.php');
                $constantsArray = array('_JSHOP_HI', '_JSHOP_YOUR_ORDER_STATUS_CHANGE', '_JSHOP_NEW_STATUS_IS', '_JSHOP_ORDER_DETAILS', '_JSHOP_COMMENT_YOUR_ORDER', '_JSHOP_CONTACT_PHONE', '_JSHOP_CONTACT_FAX');
                foreach ($constantsArray as $constant) {
                    if ($fileArray !== FALSE){
                        $view->assign(strtolower(substr($constant, 1)), $this->getConstantTranslate($fileArray, $constant));
                    } else {
                        if (defined($constant)) $constant_val = constant($constant); else $constant_val = $constant;
                        $view->assign(strtolower(substr($constant, 1)), $constant_val);
                    }
                }

                $message[$lang->language] = $view->loadTemplate();
            }
        } else {
            $text = unserialize($orderStatus->email_text);
            foreach($languages as $lang){
                $message[$lang->language] = $text['text_'.$lang->language];
            }
        }

        $view->setLayout('default');
        $view->assign('orderStatus', $orderStatus); 
        $view->assign('addonId', $addon->id);
        $view->assign('languages', $languages);
        $view->assign('message', $message);
        $view->assign('multilang', $multilang);
        $view->assign('editor', JFactory::getEditor());
        $view->display();
    }
    
    private function getConstantTranslate($fileArray, $constant){
        $constantMatch = preg_grep('/(define[ ]*[(])([ ]*)(["\'])('.$constant.')(["\'][ ]*,)/', $fileArray);
        
        if (is_array($constantMatch) && count($constantMatch)){
            $constantRow = array_shift($constantMatch);
            if (!empty($constantRow)){
                $splitConstant = preg_split('/("[ ]*,[ ]*"|\'[ ]*,[ ]*\'|"[ ]*,[ ]*\'|\'[ ]*,[ ]*"|"[ ]*[)]|\'[ ]*[)])/', $constantRow);
                
                if (is_array($splitConstant) && count($splitConstant) > 2){
                    return $splitConstant[1];
                }
            }
        }
		
		if (defined($constant)){
            return constant($constant);
        }else{
            return $constant;
        }
    }
    
    public function cancel(){
        $addonId = JRequest::getInt('addonId');
        JFactory::getApplication()->redirect('index.php?option=com_jshopping&controller=addons&task=edit&id='.$addonId);
    }
}