<?php
defined('_JEXEC') or die;

class plgJoomGalleryJoomgallerysynchrony extends JPlugin
{
    public function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);
        
        $this->loadLanguage();
    }
    
    public function onContentAfterSave($context, &$image, $isNew)
    {
        if ($isNew)            return NULL;
        
        $this->_factoryInludeJS();
        
        $lang = JSFactory::getLang();
        $post = JRequest::get('post');
        
        $imgAlias = isset($image->alias) ? $image->alias : NULL;
        $prodNameFieldJS = $lang->get("name");
        $prodAliasFieldJS = $lang->get("alias");
        $prodDescFieldJS = $lang->get("description");
        $imgPrice = isset($post["additional"]["price"]) ? $post["additional"]["price"] : 0;
        
        if (!$imgAlias || !$prodAliasFieldJS)            return NULL;
        
        $db = JFactory::getDBO();
        $query = $db->getQuery(true)
              ->select('p.product_id')
              ->from('#__jshopping_products AS p')
              ->where("p.`".$prodAliasFieldJS."` = '".$imgAlias."'");
        
        $db->setQuery($query);
        $prodIdJS = $db->loadResult();
        
        if (!$prodIdJS)            return NULL;
        
        $productJS = JTable::getInstance('product', 'jshop');
        $productJS->load($prodIdJS);
        $productJS->{$prodNameFieldJS}  = $image->imgtitle;
        $productJS->{$prodDescFieldJS}  = $image->imgtext;
        $productJS->product_publish     = $image->published;
        $productJS->access              = $image->access;
        $productJS->product_price       = saveAsPrice($imgPrice);
        $productJS->min_price           = saveAsPrice($imgPrice);
        
        $modLang  = $this->_modelInclude("languages");
        $languages = $modLang->getAllLanguages(1);
        foreach($languages as $lang)
        {
          $productJS->{"name_".$lang->language}  = $image->imgtitle;
          $productJS->{"description_".$lang->language}  = $image->imgtext;
        }
        
        if ( !$productJS->store() ) {
            JError::raiseWarning(100, PLG_JG_STORE_PRODUCT_PRICE_ERROR);
        }
    }
    
    public function onJoomAfterUpload($image)
    {
        $this->_factoryInludeJS();
        $jshopConfig = JSFactory::getConfig();
        $configJG = JoomConfig::getInstance();

        $data = array();
        $data["currency_id"] = "1";
        $data["unlimited"] = "1";
        $data['product_quantity'] = saveAsPrice("1");
        $data["product_tax_id"] = "1";
        $data["product_publish"] = $image->published;
        $data["access"] = $image->access;
        $data['product_date_added'] = getJsDate();
        $data['min_price'] = $data['product_price'] = saveAsPrice("0");
        $data["product_ean"] = $image->id;
        
        $modProds = $this->_modelInclude("Products");
        $modLang  = $this->_modelInclude("languages");
        
        $languages = $modLang->getAllLanguages(1);
        foreach($languages as $lang)
        {
          $data['name_'.$lang->language] = trim($image->imgtitle);            
          $data['description_'.$lang->language] = $image->imgtext;
          $data['alias_'.$lang->language] = $image->alias;
        }
        
//        $catIdJG = $image->catid;
        $catIdJG = $this->_checkCategoryExistJS($image->catid);
        if (!$catIdJG) {
            $catIdJG = $this->_createCategoryJS($image->catid);
        }
        
        $product = JTable::getInstance('product', 'jshop');
        
        if ( !$product->bind($data) ) {
          JError::raiseWarning(100, PLG_JG_BIND_PRODUCT_ERROR);
        }

        $product->image = $image->imgfilename;

        if ( !$product->store() ) {
            JError::raiseWarning(100, PLG_JG_STORE_PRODUCT_ERROR);
        }

        if ($product->parent_id == 0) {
            $modProds->setCategoryToProduct($product->product_id, array($catIdJG));
        }
        
        $catInfo    = $this->_getCategoryInfoJG($image->catid);
        $catPath    = $catInfo->catpath;
        $imgPathJS  = $jshopConfig->image_product_path;
                
        $srcDetail      = JPATH_ROOT ."/". $configJG->get('jg_pathimages'). $catPath ."/". $image->imgfilename;
        $srcThumb       = JPATH_ROOT ."/". $configJG->get('jg_paththumbs').$catPath ."/". $image->imgfilename;
        $srcOriginal    = JPATH_ROOT ."/". $configJG->get('jg_pathoriginalimages'). $catPath ."/". $image->imgfilename;
        
        $destDetail     = $imgPathJS ."/". $image->imgfilename;
        $destThumb      = $imgPathJS ."/thumb_". $image->imgfilename;
        $destOriginal   = $imgPathJS ."/full_". $image->imgfilename;
        
        if ( !JFile::copy($srcDetail, $destDetail) ) {
            JError::raiseWarning(100, PLG_JG_COPY_DETAIL_IMAGE_ERROR);
        }
        if ( !JFile::copy($srcThumb, $destThumb) ) {
            JError::raiseWarning(100, PLG_JG_COPY_THUMB_IMAGE_ERROR);
        }
        if ( !JFile::copy($srcDetail, $destOriginal) ) {
            JError::raiseWarning(100, PLG_JG_COPY_ORIGINAL_IMAGE_ERROR);
        }
        
        $imageJS = JTable::getInstance('image', 'jshop');
        $imageJS->set("image_id", 0);
        $imageJS->set("product_id", $product->product_id);
        $imageJS->set("image_name", $image->imgfilename);
        $imageJS->set("ordering", $imageJS->getNextOrder("product_id='".intval($product->product_id)."'"));
        $imageJS->store();
        
        if ( !JFile::copy($srcOriginal, $jshopConfig->files_product_path."/".$image->imgfilename) ) {
            JError::raiseWarning(100, PLG_JG_COPY_ORIGINAL_FILE_ERROR);
        }
        else {
            $this->_addToProductFilesJS($product->product_id, NULL, NULL, $image->imgfilename, NULL, 0);
        }
        
        $db = JFactory::getDBO();
        $query = "INSERT INTO `#__joomgallery_image_details` SET `id` = '.$image->id.', `details_key` = 'marketlink.productid', `details_value` = '$product->product_id'";
        $db->setQuery($query);
        $db->query();
    }
    
    private function _addToProductFilesJS($product_id, $file_demo, $demo_descr, $file_sale, $file_descr, $sort)
    {
        $db = JFactory::getDBO();
        $query = "INSERT INTO `#__jshopping_products_files` SET `product_id` = '".$db->escape($product_id)."', `demo` = '".$db->escape($file_demo)."',  `demo_descr` = '".$db->escape($demo_descr)."', `file` = '".$db->escape($file_sale)."', `file_descr` = '".$db->escape($file_descr)."', `ordering`='".$db->escape($sort)."'";
        $db->setQuery($query);
        $db->query();
    }
    
    private function _checkCategoryExistJS($catIdJG)
    {
        $db = JFactory::getDBO();
        
        $catIdJG = intval($catIdJG);
        if (!$catIdJG)            return NULL;
        
        $catInfo = $this->_getCategoryInfoJG($catIdJG);

        $modLang = $this->_modelInclude("languages");
        $languages = $modLang->getAllLanguages(1);
        
        $where = " WHERE 0 ";
        foreach($languages as $lang){
            $where .= " OR `alias_".$lang->language."` = '".$catInfo->alias."'";
        }
        $query = "SELECT * FROM `#__jshopping_categories` ".$where;
        $db->setQuery($query);
        $catJS = $db->loadObject();
        
        return $catJS ? $catJS->category_id : FALSE;
    }
    
    private function _createCategoryJS($catIdJG)
    {
        $catIdJG = intval($catIdJG);
        if (!$catIdJG)            return NULL;
        
        $catInfo = $this->_getCategoryInfoJG($catIdJG);
        
        $data = array();
        $data["category_id"] = NULL;
        $data["access"] = "1";
        $data["category_publish"] = "1";
        
        $modLang = $this->_modelInclude("languages");
        $languages = $modLang->getAllLanguages(1);
        
        foreach($languages as $lang){
            $data['name_'.$lang->language] = trim($catInfo->name);
            $data['alias_'.$lang->language] = $catInfo->alias;
            $data['description_'.$lang->language] = $catInfo->description;
        }
        
        $category = JTable::getInstance("category", "jshop");
        
        if (!$category->bind($data)) {
          JError::raiseWarning(100, PLG_JG_BIND_CATEGORY_ERROR);
        }
        if (!$category->store()) {
          JError::raiseWarning(100, PLG_JG_STORE_CATEGORY_ERROR);
        }
        
        return isset($category->category_id) ? $category->category_id : NULL;
    }
    
    private function _getCategoryInfoJG($catid)
    {
        $catid = intval($catid);
        if (!$catid)            return NULL;
        
        $db = JFactory::getDBO();
        $query = $db->getQuery(true)
              ->select('jg.*')
              ->from(_JOOM_TABLE_CATEGORIES.' AS jg')
              ->where('jg.cid = '.$catid);
        
        $db->setQuery($query);
        $catInfo = $db->loadObject();
        
        return $catInfo;
    }
    
    private function _factoryInludeJS()
    {
        require_once (JPATH_SITE.'/components/com_jshopping/lib/factory.php'); 
        require_once (JPATH_SITE.'/components/com_jshopping/lib/functions.php');
    }

    private function _modelInclude($type, $prefix = 'JshoppingModel', $config = array())
    {
        jimport('joomla.application.component.model');
        JModelLegacy::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_jshopping/models');
        $model = JModelLegacy::getInstance($type, $prefix, $config);
        
        return $model;
    }
}