<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.helper');
class plgJshoppingCheckoutAddon_attributes_policy extends JPlugin {
    
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
        $this->loadLanguage();
	}
        public function onAfterCartGetReturnPolicy(&$cart, &$rows){
                $def_ret_policy = $this->getDefaultReturnPolicy();
                $rows = array();
                $ind_attr = array();
                $ids = array();             
                $statictext = JTable::getInstance("statictext","jshop");
                $_ind_attr = $this->getIndependentAttr();
                if (is_array($_ind_attr)){
                    foreach ($_ind_attr as $value) {
                        $ind_attr[] = $value->attr_id;
                    }
                }
                if (is_array($cart->products)){
                    foreach ($cart->products as $product) {
                        $temp_ids = array();
                        $depend_attr = array();
                        $prod_policy = $this->getReturnPolicyForProduct($product['product_id']);
                        if ($prod_policy) $temp_ids[] = $prod_policy;
                        if (is_array($product['attributes_value'])){
                            foreach ($product['attributes_value'] as  $attr) {
                                if (in_array($attr->attr_id, $ind_attr)){
                                    $ind_policy = $this->getCartPolicyId($attr, $product['product_id']);
                                    if ($ind_policy) $temp_ids[] = $this->getCartPolicyId($attr, $product['product_id']);
                                }                                    
                                else 
                                $depend_attr[] = $attr;
                            }
                        }
                        if (count($depend_attr)){
                            $dep_policy = $this->getCartPolicyId2($depend_attr, $product['product_id']);
                            if ($dep_policy) $temp_ids[] = $dep_policy;                            
                        }
                        if (count($temp_ids)){
                            $ids = array_merge($ids,$temp_ids);                                  
                        } else {
                            $ids[]= $def_ret_policy;
                        }
                    }                    
                }
                
            $ids = array_unique($ids);
            $_ids = array();
            foreach ($ids as $key => $value) {
                if ($value>0) $_ids[$key] = $value;
            }
            $text = $statictext->loadDataByIds($_ids);
            if (is_array($text)){
                foreach ($text as $row) {
                    $rows []= $row;               
                }
            }                
        }
        
        public function onBeforeDisplayCheckoutStep5View(&$view){
            if ($view->attr_no_return)
            $view->no_return = 1;
        }        
        
	public function onBeforeDisplayCheckoutStep5(&$sh_method, &$pm_method, &$delivery_info, &$cart, &$view){
            $list_attr_no_return = array();
            $jshopConfig = JSFactory::getConfig();
            if ($jshopConfig->return_policy_for_product) {
               $ind_attr = array();
                
                $_ind_attr = $this->getIndependentAttr();
                if (is_array($_ind_attr)){
                    foreach ($_ind_attr as $value) {
                        $ind_attr[] = $value->attr_id;
                    }
                }
                if (is_array($cart->products)){
                    foreach ($cart->products as $product) {
                        $depend_attr = array();
                        if (is_array($product['attributes_value'])){
                            foreach ($product['attributes_value'] as  $attr) {
                                if (in_array($attr->attr_id, $ind_attr))
                                    $list_attr_no_return[] = $this->getNoReturn($attr, $product['product_id']);
                                else 
                                $depend_attr[] = $attr;
                            }
                        }
                        if (count($depend_attr)){  
                            $list_attr_no_return[] = $this->getNoReturn2($depend_attr, $product['product_id']);
                        }
                    }                    
                } 
            $no_return = intval(in_array('1', $list_attr_no_return));
            if ($no_return)
            $view->attr_no_return = 1;              
            }           
    }
    
        public function getIndependentAttr(){
            $db = JFactory::getDBO();
            $query = "SELECT attr_id FROM `#__jshopping_attr` WHERE `independent` = 1";
            $db->setQuery($query);
            return $db->loadObjectList();
        }
        
        public function getNoReturn($attr, $product_id){
            $db = JFactory::getDBO();
            $query = "SELECT no_return FROM `#__jshopping_products_attr2` WHERE `attr_id` = '".$db->escape($attr->attr_id)."' AND `attr_value_id` = '".$db->escape($attr->value_id)."' AND `product_id` = '".$db->escape($product_id)."'";
            $db->setQuery($query);
            return $db->loadResult();
        } 
        
        public function getNoReturn2($attr, $product_id){
            $db = JFactory::getDBO();
            $where = " `product_id` = '".$db->escape($product_id)."' ";
            foreach ($attr as $value) {
                $where .= " AND `attr_".$value->attr_id."` = '".$db->escape($value->value_id)."'";
            }
            
            $query = "SELECT no_return FROM `#__jshopping_products_attr` WHERE ".$where;
            $db->setQuery($query);
            return $db->loadResult();
        }
        
        public function getCartPolicyId($attr, $product_id){
            $db = JFactory::getDBO();
            $query = "SELECT policy_id FROM `#__jshopping_products_attr2` WHERE `attr_id` = '".$db->escape($attr->attr_id)."' AND `attr_value_id` = '".$db->escape($attr->value_id)."' AND `product_id` = '".$db->escape($product_id)."'";
            $db->setQuery($query);
            return $db->loadResult();
        }    

        public function getCartPolicyId2($attr, $product_id){
            $db = JFactory::getDBO();
            $where = " `product_id` = '".$db->escape($product_id)."' ";
            foreach ($attr as $value) {
                $where .= " AND `attr_".$value->attr_id."` = '".$db->escape($value->value_id)."'";
            }
            
            $query = "SELECT policy_id FROM `#__jshopping_products_attr` WHERE ".$where;
            $db->setQuery($query);
            return $db->loadResult();
        }
        
        function getReturnPolicyForProduct($prod_id){
            $db = JFactory::getDBO();
            $query = "SELECT  `value` FROM `#__jshopping_products_option` WHERE product_id = ".$db->escape($prod_id)." AND `key`='return_policy' AND `value` > 0";
            $db->setQuery($query);
            return $db->loadResult();
    }

        function getDefaultReturnPolicy(){
            $db = JFactory::getDBO();
            $query = "SELECT id FROM `#__jshopping_config_statictext` WHERE `alias` = 'return_policy'";
            $db->setQuery($query);
            return $db->loadResult();
        }      
    
        
}


?>