<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.helper');
class plgJshoppingCheckoutprice_round_to_parameter extends JPlugin {
	   
        private $taxRound = FALSE;
    
	function __construct(&$subject, $config){
            parent::__construct($subject, $config);
            $this->loadLanguage();
            $this->taxRound = $this->checkTaxRound();
	}
	
	private function checkTaxRound()
        {
            $addon = JTable::getInstance("addon", "jshop");
            $addon->loadAlias('addon_price_round_to_parameter');

            $addonParams = $addon->getParams();
            $taxRound = $addonParams["tax_round"];

            return intval($taxRound) ? TRUE : FALSE;
	}
	
    private function roundToParameterPrice($value){
       $addon = JTable::getInstance('addon', 'jshop');
       $addon->loadAlias('addon_price_round_to_parameter');
       $addon_config = $addon->getParams();
       
       $prmtr = $addon_config['parameter'];
       if($prmtr < 1){

           $krok = $prmtr * 100;
           
           $value = round($value, 2);
           $value_temp = round(100*($value - floor($value)));
           
           $min_val = floor($value_temp / $krok);
           $left_val = $min_val * $krok;
           $right_val = ($min_val+1) * $krok;
           $center = floor((($left_val+$right_val) / 2) + 1);
           
           if ($value_temp < $center){
                $rest = ($left_val / 100);
           } else {
               $rest = ($right_val / 100);
           }
           
         return floor($value) + $rest;

       } else {
           
           $krok = $prmtr;
           
           $value = round($value, 2);
           $value_temp = round(100*($value - floor($value)));
           $value = floor($value);
           
           $min_val = floor($value / $krok);
           $left_val = $min_val * $krok;
           $right_val = ($min_val+1) * $krok;
           $center = floor(($left_val+$right_val) / 2);
           
           if ($value < $center){
               $result = $left_val;
           } else {
               $result = $right_val;
           }
         
         return $result;
           
       }
     }

	public function onAfterCartLoad(&$cart){
		$cart->price_product_brutto = $this->roundToParameterPrice($cart->price_product_brutto);
	}
		
	public function onBeforeDisplayCartView(&$view){
		$view->fullsumm = $this->roundToParameterPrice($view->fullsumm);
		if(count($view->tax_list) && $this->taxRound){
			foreach($view->tax_list as $k=>$v){
				$view->tax_list[$k] = $this->roundToParameterPrice($view->tax_list[$k]);
			}
		}
		if($view->discount)$view->discount = $this->roundToParameterPrice($view->discount);
	}
	
	public function onBeforeDisplayCheckoutStep3View(&$view){
		if(count($view->payment_methods)){
			foreach($view->payment_methods as $k=>$v){
				if ($view->payment_methods[$k]->price_add_text  && $v->price_type!=2){
					$tmp_arr = explode(' ', $view->payment_methods[$k]->price_add_text);
					$tmp_arr[0] = $this->roundToParameterPrice((float)$tmp_arr[0]);
					if($tmp_arr[0] > 0)$tmp_arr[0] = '+' . $tmp_arr[0]; 
					$view->payment_methods[$k]->price_add_text = $tmp_arr[0] . ' ' . $tmp_arr[1];
				}
				if($view->payment_methods[$k]->calculeprice)$view->payment_methods[$k]->calculeprice = $this->roundToParameterPrice($view->payment_methods[$k]->calculeprice);
			}
		}
	}
	
	public function onBeforeDisplayCheckoutStep4View(&$view){
		
		if(count($view->shipping_methods)){
			foreach($view->shipping_methods as $k=>$v){
				if($view->shipping_methods[$k]->calculeprice)$view->shipping_methods[$k]->calculeprice = $this->roundToParameterPrice($view->shipping_methods[$k]->calculeprice);
			}
		}
	}
	
	public function onBeforeDisplaySmallCart(&$cart){
		
		$session = JFactory::getSession();
		$jshop_price_shipping = $session->get("jshop_price_shipping");
		if($jshop_price_shipping)$session->set("jshop_price_shipping",$this->roundToParameterPrice($jshop_price_shipping));
		
		$jshop_price_package = $session->get("jshop_price_package");
		if($jshop_price_package)$session->set("jshop_price_package",$this->roundToParameterPrice($jshop_price_package));
		
		$jshop_payment_price = $session->get("jshop_payment_price");
		if($jshop_payment_price)$session->set("jshop_payment_price",$this->roundToParameterPrice($jshop_payment_price));
		
	}
	
	public function onBeforeDisplayCheckoutCartView(&$view){
		if($view->tax_list && $this->taxRound){
			foreach($view->tax_list as $k=>$v){
				$view->tax_list[$k] = $this->roundToParameterPrice($view->tax_list[$k]);
			}
		}
		$view->fullsumm = $this->roundToParameterPrice($view->fullsumm);
		if($view->discount)$view->discount = $this->roundToParameterPrice($view->discount);
	}
	
	public function onBeforeCreateOrder(&$order){

		$order->order_total = $this->roundToParameterPrice($order->order_total);
		$order->order_subtotal = $this->roundToParameterPrice($order->order_subtotal);
		if($this->taxRound){
			$order->order_tax = $this->roundToParameterPrice($order->order_tax);
		}
		$order->order_shipping = $this->roundToParameterPrice($order->order_shipping);
		$order->order_payment = $this->roundToParameterPrice($order->order_payment);
		$order->order_discount = $this->roundToParameterPrice($order->order_discount);
		if($order->order_package)$order->order_package = $this->roundToParameterPrice($order->order_package);
		
        $order_tax_ext = unserialize($order->order_tax_ext);        
		if($this->taxRound)
        foreach($order_tax_ext as $k=>$v){
            $order_tax_ext[$k] = $this->roundToParameterPrice($v);
        }        
		$order->order_tax_ext = serialize($order_tax_ext);
	}
}
?>