<?php
defined('_JEXEC') or die('Restricted access');

class plgJshoppingCheckoutUserregistration extends JPlugin {
    const password_length = 8;
    
    function __construct(&$subject, $config){
        parent::__construct($subject, $config);
        $this->loadLanguage();
    }
    
    public function onLoadCheckoutStep2save(){
        $user = JFactory::getUser();
        // if user is guest
        if ( $user->guest ){
            $post = JRequest::get('post');
            // if email is exist
            if ($this->checkEmailExist($post)){
                JError::raiseNotice(100, JText::_("PLG_JSHOPPINGCHECKOUT_USERREGISTRATION_NOTICE_EMAILEXIST"));
                $app = JFactory::getApplication();
                $app->redirect(JRoute::_("index.php?option=com_jshopping&controller=checkout&task=step2"));
            }else{
                $this->userRegistration($post);
            }
        }
    }
    
    private function checkEmailExist($post){
        if (isset($post["email"]) && strlen($post["email"]) > 0){
            $db = JFactory::getDBO();            
            $query = "SELECT user_id FROM `#__jshopping_users` WHERE email='".$db->escape($post["email"])."' and guest=0";
            $db->setQuery($query);
            $db->query();
            if ( $db->getNumRows() ) {
                return TRUE;
            }
        }
        return FALSE;
    }
    
    private function userRegistration($post){
		$session = JFactory::getSession();
		$mainframe = JFactory::getApplication();	
		$params = JComponentHelper::getParams('com_users');
        $data = array();
		
		$db = JFactory::getDBO();            
        $query = "SELECT user_id FROM `#__jshopping_users` WHERE email='".$db->escape($post["email"])."'";
        $db->setQuery($query);
        $guestid = $db->loadResult();
        
        $data['groups'][]   = $params->get('new_usertype', 2);
        $data['email']      = $post["email"];
        $data['name']       = $post['f_name'].' '.$post['l_name'];
        $data['username']   = $post["email"];        
        $data['block']      = 0;
        $data['activation'] = "";

        $password = $this->generatePassword(self::password_length);
        $data['password'] = $data['password2'] = $password;
        
		$mess_status = $this->params->get('mess_status', 1);
		
		if (!$guestid){
			$user = new JUser;        
			$user->bind($data);        
			$user->save();
			
			$userShop = JTable::getInstance('userShop', 'jshop');
			$userShop->addUserToTableShop($user);
			$userShop->guest = 1;		
			$userShop->bind($post);
			$userShopStore = $userShop->store();
			
			$session->set('guestuserid', $user->id);
		}else{
			$userShop = JTable::getInstance('userShop', 'jshop');
			$userShop->load($guestid);
			$userShop->guest = 1;		
			$userShop->bind($post);
			$userShopStore = $userShop->store();
			
			$session->set('guestuserid', $guestid);
		}

		if ($userShopStore && $mess_status && !$guestid){
			$mailfrom = $mainframe->getCfg('mailfrom');
			$fromname = $mainframe->getCfg('fromname');	
			$recipient = $userShop->email;			
			$subject = $fromname;
			$body = JText::_("PLG_JSHOPPINGCHECKOUT_USERREGISTRATION_MESSAGE_HELLO")." ".$user->name ."\n\n"
				   .JText::_("PLG_JSHOPPINGCHECKOUT_USERREGISTRATION_MESSAGE_TEXT")."\n\n"
				   .JText::_("PLG_JSHOPPINGCHECKOUT_USERREGISTRATION_MESSAGE_USERNAME").": ".$userShop->email ."\n"
				   .JText::_("PLG_JSHOPPINGCHECKOUT_USERREGISTRATION_MESSAGE_PASSWORD").": ".$password ."\n";
			
			$this->sendMail($mailfrom, $fromname, $recipient, $subject, $body);
		}        
    }
    
    private function generatePassword($pass_length) 
    {
		$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";	

		$password = "";
		$size = strlen($chars);
			
		for( $i = 0; $i < $pass_length; $i++ ) 
		{
				$password .= $chars[rand(0, $size - 1)];
		}

	return $password;
    }
    
    private function sendMail($from, $fromname, $recipient, $subject, $body, $mode=0, $cc=null, $bcc=null, $attachment=null, $replyto=null, $replytoname=null)
    {
        // Get a JMail instance
        $mail = JFactory::getMailer();

        $mail->setSender(array($from, $fromname));
        $mail->setSubject($subject);
        $mail->setBody($body);

        // Are we sending the email as HTML?
        if ($mode) {
                $mail->IsHTML(true);
        }

        $mail->addRecipient($recipient);
        $mail->addCC($cc);
        $mail->addBCC($bcc);
        $mail->addAttachment($attachment);

        // Take care of reply email addresses
        if (is_array($replyto)) {
                $numReplyTo = count($replyto);
                for ($i=0; $i < $numReplyTo; $i++){
                        $mail->addReplyTo(array($replyto[$i], $replytoname[$i]));
                }
        } elseif (isset($replyto)) {
                $mail->addReplyTo(array($replyto, $replytoname));
        }

        return  $mail->Send();
    }
}