<?php
defined('_JEXEC') or die('Restricted access');

class plgJshoppingCheckoutWebgains extends JPlugin
{
    public function __construct(&$subject, $config = array()){
        parent::__construct($subject, $config);  
    }
    
    public function onBeforeDisplayCheckoutFinish(&$text, &$order_id){
        if ($order_id){
            $jshopConfig = JSFactory::getConfig();
            $order = JTable::getInstance('order', 'jshop');
            $order->load($order_id);
			$order->getAllItems();
			if ($order->coupon_id) {
				$coupon = JTable::getInstance('coupon', 'jshop'); 
				$coupon->load($order->coupon_id);
			}
            
            $currency_value = NULL;
            $allowedCurrencies = array('AUD','CAD','CHF','CZK','DKK','EUR','GBP','HKD','HUF','JPY','NOK','NZD','PLN','SEK','SGD','SKK','USD');
            if (!in_array($order->currency_code_iso, $allowedCurrencies)){
                $allCurrencies = JSFactory::getAllCurrency();
                foreach ($allCurrencies as $currency){
                    if ($currency->currency_code_iso == 'EUR'){
                        $currency_value = $currency->currency_value;
                        break;
                    }
                }

                if ($currency_value === NULL){
                    $currency_value = 1;
                    JError::raiseWarning('', 'Webgains. Euro currency not found');
                }
            }
            
            $coupon_code = ($order->coupon_id) ? $order->coupon_code : '';

            $wgOrderReference = rawurlencode(SEFLink('index.php?option=com_jshopping&controller=user&task=order&order_id='.$order->order_id, 0, 0, $jshopConfig->use_ssl));
            $wgVoucherCode = rawurlencode($coupon_code); #(Optional) String, in welchem Sie den Gutscheincode hinterlegen können, welcher für diese Transaktion verwendet wurde

            $wgEventID = $this->params->get('eventID', 14167); # identifiziert die Provisionsart, die Sie in unserem System aufgesetzt haben. Um die korrekten Nummern zu finden gehen Sie unter Programmeinstellungen/Provisionsarten.
            $wgComment = $this->params->get('comment', ''); # optionales Feld
            $wgMultiple = 1;

            $products = array();
            foreach ($order->items as $order_item) {
                $itemPrice = $order_item->product_item_price * $order_item->product_quantity;
                
                if ($currency_value){
                    $itemPrice = $itemPrice / $order->currency_exchange * $currency_value;
                }

                $products[] = $wgEventID.'::'.$itemPrice.'::'.$order_item->product_name.'::'.$order_item->product_ean.'::';
            }
            
            if ($currency_value === NULL){
                $products[] = $wgEventID.'::'.$order->order_shipping.'::'._JSHOP_SHIPPING_PRICE.'::::';
            } else {
                $products[] = $wgEventID.'::'.($order->order_shipping / $order->currency_exchange * $currency_value).'::'._JSHOP_SHIPPING_PRICE.'::::';
            }

            if ($jshopConfig->display_price_front_current) {
                if ($currency_value === NULL){
                    $products[] = $wgEventID.'::'.$order->order_tax.'::'._JSHOP_PLUS_TAX.'::::';
                } else {
                    $products[] = $wgEventID.'::'.($order->order_tax / $order->currency_exchange * $currency_value).'::'._JSHOP_PLUS_TAX.'::::';
                }
            }
            
            if ($order->coupon_id) {
                if ($currency_value === NULL){
                    $products[] = $wgEventID.'::-'.$order->order_discount.'::'.$order->coupon_code.'::::'; // discount
                } else {
                    $products[] = $wgEventID.'::-'.($order->order_discount / $order->currency_exchange * $currency_value).'::'.$order->coupon_code.'::::'; // discount
                }
            }
            
            $wgItems = rawurlencode(implode('|', $products)); 

            /*    (Optional) Kann eine durch Pipe separierte Liste von Einkaufskorbartikeln enthalten. Nur notwendig bei unterschiedlichen Provisionsarten auf verschiedene Produktgruppen. Weitere Informationen finden Sie im Dokument "wgitems.pdf" auf Anfrage  */
            $wgCustomerID = $this->params->get('customerID', ''); # Bitte nicht ohne vorherige Absprache verwenden
            $wgProductID = $this->params->get('productID', ''); # Bitte nicht ohne vorherige Absprache verwenden
            /*    </Variablen deren Werte im Durchlauf zugewiesen werden>    */

            /*    <Variablen deren Werte vor der Integration festgelegt werden>    */
            $wgSLang = 'php';# String, welche die Programmiersprache Ihres Systems identifziert. Wird wegen der unterschiedlichen URL-Kodierung auf verschiedenen Platformen benötigt.
            $lang = JFactory::getLanguage();

            $wgLang = str_replace('-', '_', $lang->getTag()); # String, welcher die Sprache der Transaktion identifiziert
            $wgPin = $this->params->get('pin', ''); # PIN-Nummer, welche Ihnen von Webgains zur Verfügung gestellt wird (im Account unter Program Einstellungen (Program Einstellungen -> Technischer Setup))
            $wgProgramID = $this->params->get('programID', '');; # int. Identifiziert Ihr Programm im Webgains-System
            /*    </Variablen deren Werte vor der Integration festgelegt werden>    */
            
            
            if ($currency_value === NULL){
                $wgOrderValue = $order->order_total;# Gesamtsumme in Euro mit "." (Punkt) als Dezimaltrenner (Keine Waehrungsangaben!)
                $wgCurrency = $order->currency_code_iso;
            } else {
                $wgCurrency = 'EUR';
                $wgOrderValue = ($order->order_total / $order->currency_exchange) * $currency_value;
            }

            /*    <Bitte nicht aendern>    */
            $wgVersion = '1.2';
            $wgSubDomain = "track";
            $wgCheckString = "wgver=$wgVersion&wgsubdomain=$wgSubDomain&wglang=$wgLang&wgslang=$wgSLang&wgprogramid=$wgProgramID&wgeventid=$wgEventID&wgvalue=$wgOrderValue&wgorderreference=$wgOrderReference&wgcomment=$wgComment&wgmultiple=$wgMultiple&wgitems=$wgItems&wgcustomerid=$wgCustomerID&wgproductid=$wgProductID&wgvouchercode=$wgVoucherCode";
            $wgCheckSum = md5($wgPin.$wgCheckString); # Generiere Checksumme
            $wgQueryString = $wgCheckString."&wgchecksum=".$wgCheckSum."&wgCurrency=".$wgCurrency;
            $wgUri = '://'.$wgSubDomain.".webgains.com/transaction.html?".$wgQueryString;
            /*    </Bitte nicht aendern>    */
            
            JFactory::getDocument()->addScriptDeclaration('
                if (location.protocol.toLowerCase() == "https:") wgProtocol = "https";
                else wgProtocol = "http";
                wgUri = wgProtocol + "'.$wgUri.'" + "&wgprotocol=" + wgProtocol + "&wglocation=" + location.href;
                
                document.write(\'<sc\'+\'ript language = "JavaScript" type = "text/javascript" src="\'+wgUri+\'"></sc\'+\'ript>\');
            ');
            
            $text .= '<noscript><img src="http://'.$wgSubDomain.'.webgains.com/transaction.html?wgrs=1&'.$wgQueryString.'&wgprotocol=https" alt="" width="1" height="1"/></noscript><p>'._JSHOP_THANK_YOU_ORDER.'</p>';
		}
    }
}